import "Turbine"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Turbine.Gameplay"
import "CajePlugins.HUDPlus.Controls"
import "CajePlugins.HUDPlus.OptionsMenu"
import "CajePlugins.HUDPlus.Meter"
import "CajePlugins.HUDPlus.Color"
import "CajePlugins.HUDPlus.Effects"
import "CajePlugins.HUDPlus.UIUtils"
import "CajePlugins.HUDPlus.Scans"

LoadTime = Turbine.Engine.GetLocalTime()
QSLoadTime = ( LoadTime + 120 )
FrameTime = Turbine.Engine.GetGameTime()

HUDVis = "1"
HUDVischanging = "0"
EffL = "0"

MousePosX = Turbine.UI.Display.GetMouseX()
MousePosY = Turbine.UI.Display.GetMouseY()

LOADED = "0"

MLastPot = "0"
PLastPot = "0"
PoLastPot = "0"
DLastPot = "0"
FLastPot = "0"
WLastPot = "0"

LFading = "1"
MWarnFlashOut = "0"
MWarnFlashIn = "0"
PWarnFlashOut = "0"
PWarnFlashIn = "0"
Dismissednum = 0

HUDPlus = Turbine.Plugin
version = Plugins["HUDPlus"]:GetVersion();
Turbine.Shell.WriteLine( "HUDPlus "..version.." by Caje" )

function Primwin:DefinePlayer()
	Player = Turbine.Gameplay.LocalPlayer.GetInstance();
	PlayerClass = Player:GetClass()
	EffectList = Player:GetEffects()
	if PlayerClass == Turbine.Gameplay.Class.Champion
	then ChmpAtts = Player:GetClassAttributes()
		function ChmpAtts:FervorChanged()
			CurFervour = ChmpAtts:GetFervor()
			MeterBar:SetPosition( ( CurFervour * 51 ) - 255, 0 )
		end
	ChmpAtts:FervorChanged()
	elseif PlayerClass == Turbine.Gameplay.Class.Hunter
	then HntAtts = Player:GetClassAttributes()
		function HntAtts:FocusChanged()
			CurFocus = HntAtts:GetFocus()
			MeterBar:SetPosition( ( CurFocus * 28.3333 ) - 255, 0 )
		end
	HntAtts:FocusChanged()
	elseif PlayerClass == Turbine.Gameplay.Class.RuneKeeper
	then RKAtts = Player:GetClassAttributes()
		function RKAtts:AttunementChanged()
			CurAtt = RKAtts:GetAttunement()
			MeterBar:SetPosition( ( math.abs(CurAtt - 10) * 28.3333 ) - 255, 0 )
			if CurAtt < 10 then MeterBar:SetBackColor( red )
			elseif CurAtt > 10 then MeterBar:SetBackColor( classgreen )
			end
		end
	RKAtts:AttunementChanged()
	end
end

StartMorale = Player:GetMorale()



function HUDPlus:SaveData()
	HUDPlusData = { }
	HUDPlusData.CritLevel = ( CriticalScroll:GetValue() / 100 )
	HUDPlusData.LowLevel = ( LowScroll:GetValue() / 100 )
	HUDPlusData.PCritLevel = ( PCriticalScroll:GetValue() / 100 )
	HUDPlusData.PLowLevel = ( PLowScroll:GetValue() / 100 )
	HUDPlusData.DLevel = ( DHitScroll:GetValue() )
	HUDPlusData.quickslots = quickslots
	HUDPlusData.Bars = Bars
	HUDPlusData.Meter = Meter
	HUDPlusData.Moralewarn = Moralewarn
	HUDPlusData.Powerwarn = Powerwarn
	HUDPlusData.PancD = PanCD
	HUDPlusData.BubCD = BubCD
	HUDPlusData.Text = Text
	HUDPlusData.CorruptionCD = CorruptionCD
	HUDPlusData.InterruptCD = InterruptCD
	HUDPlusData.DHitWarning = DHitWarning
	HUDPlusData.Cus1CD = Cus1CD
	HUDPlusData.Cus2CD = Cus2CD
	HUDPlusData.IndOnly = IndOnly
	HUDPlusData.MWopT = MWopT
	HUDPlusData.PWopT = PWopT
	HUDPlusData.DHopT = DHopT
	HUDPlusData.BopT = BopT
	HUDPlusData.MopT = MopT
	HUDPlusData.MData = MShortcut:GetData()
	HUDPlusData.PData = PShortcut:GetData()
	HUDPlusData.DData = DShortcut:GetData()
	HUDPlusData.WData = WShortcut:GetData()
	HUDPlusData.FData = FShortcut:GetData()
	HUDPlusData.PoData = PoShortcut:GetData()
	HUDPlusData.MType = MShortcut:GetType()
	HUDPlusData.PType = PShortcut:GetType()
	HUDPlusData.DType = DShortcut:GetType()
	HUDPlusData.WType = WShortcut:GetType()
	HUDPlusData.FType = FShortcut:GetType()
	HUDPlusData.PoType = PoShortcut:GetType()
	HUDPlusData.Panskill = Pantext:GetText()
	HUDPlusData.Corskill = Cortext:GetText()
	HUDPlusData.Intskill = Inttext:GetText()
	HUDPlusData.Bubskill = Bubtext:GetText()
	HUDPlusData.C1skill = C1text:GetText()
	HUDPlusData.C2skill = C2text:GetText()
	HUDPlusData.PanicCD = PanScroll:GetValue()
	HUDPlusData.CorCD = CorScroll:GetValue()
	HUDPlusData.IntCD = IntScroll:GetValue()
	HUDPlusData.BubbCD = BubScroll:GetValue()
	HUDPlusData.C1CD = C1Scroll:GetValue()
	HUDPlusData.C2CD = C2Scroll:GetValue()
	HUDPlusData.OOCcrit = OOCcrit
	HUDPlusData.Cus1CD = Cus1CD
	HUDPlusData.Cus2CD = Cus2CD
	HUDPlusData.MWarnX = MWarn:GetLeft()
	HUDPlusData.MWarnY = MWarn:GetTop()
	HUDPlusData.PWarnX = PWarn:GetLeft()
	HUDPlusData.PWarnY = PWarn:GetTop()
	HUDPlusData.DHitWarnX = DHitWarn:GetLeft()
	HUDPlusData.DHitWarnY = DHitWarn:GetTop()
	HUDPlusData.PanicCDX = PanicCD:GetLeft()
	HUDPlusData.PanicCDY = PanicCD:GetTop()
	HUDPlusData.BubbleCDX = BubbleCD:GetLeft()
	HUDPlusData.BubbleCDY = BubbleCD:GetTop()
	HUDPlusData.CorrCDX = CorrCD:GetLeft()
	HUDPlusData.CorrCDY = CorrCD:GetTop()
	HUDPlusData.IntCDX = IntCD:GetLeft()
	HUDPlusData.IntCDY = IntCD:GetTop()
	HUDPlusData.C1CDX = C1CD:GetLeft()
	HUDPlusData.C1CDY = C1CD:GetTop()
	HUDPlusData.C2CDX = C2CD:GetLeft()
	HUDPlusData.C2CDY = C2CD:GetTop()
	HUDPlusData.loadwithman = loadwithman

	HUDPlusData.MQSGX = MQSG:GetLeft()
	HUDPlusData.MQSGY = MQSG:GetTop()
	HUDPlusData.PQSGX = PQSG:GetLeft()
	HUDPlusData.PQSGY = PQSG:GetTop()
	HUDPlusData.DQSGX = DQSG:GetLeft()
	HUDPlusData.DQSGY = DQSG:GetTop()
	HUDPlusData.WQSGX = WQSG:GetLeft()
	HUDPlusData.WQSGY = WQSG:GetTop()
	HUDPlusData.FQSGX = FQSG:GetLeft()
	HUDPlusData.FQSGY = FQSG:GetTop()
	HUDPlusData.PoQSGX = PoQSG:GetLeft()
	HUDPlusData.PoQSGY = PoQSG:GetTop()
	HUDPlusData.MBarX = MBarWin:GetLeft()
	HUDPlusData.MBarY = MBarWin:GetTop()
	HUDPlusData.PBarX = PBarWin:GetLeft()
	HUDPlusData.PBarY = PBarWin:GetTop()
	HUDPlusData.MTWinX = MTWin:GetLeft()
	HUDPlusData.MTWinY = MTWin:GetTop()
	HUDPlusData.PTWinX = PTWin:GetLeft()
	HUDPlusData.PTWinY = PTWin:GetTop()
	HUDPlusData.TTWinX = TTWin:GetLeft()
	HUDPlusData.TTWinY = TTWin:GetTop()
	HUDPlusData.MeterBarX = MeterWin:GetLeft()
	HUDPlusData.MeterBarY = MeterWin:GetTop()

	HUDPlus:SaveData2()

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HUDPlus", HUDPlusData )
end

--[[ Disabled for quickslot quantity indicators
function HUDPlus:SaveFlags()
	HUDPlusFlags = { }
	HUDPlusFlags.MLastPot = MLastPot
	HUDPlusFlags.PLastPot = PLastPot
	HUDPlusFlags.DLastPot = DLastPot
	HUDPlusFlags.WLastPot = WLastPot
	HUDPlusFlags.FLastPot = FLastPot
	HUDPlusFlags.PoLastPot = PoLastPot

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HUDPlusF", HUDPlusFlags )
end
]]
function HUDPlus:SaveData2()
	HUDPlusData2 = { }
	--COLOR--------------------------------------------------------------------------------

	HUDPlusData2.mbackcolor = {}
	HUDPlusData2.mbackcolor.rcomp = rcompmbackcolor
	HUDPlusData2.mbackcolor.gcomp = gcompmbackcolor
	HUDPlusData2.mbackcolor.bcomp = bcompmbackcolor

	HUDPlusData2.m2backcolor = {}
	HUDPlusData2.m2backcolor.rcomp = rcompm2backcolor
	HUDPlusData2.m2backcolor.gcomp = gcompm2backcolor
	HUDPlusData2.m2backcolor.bcomp = bcompm2backcolor

	HUDPlusData2.m3backcolor = {}
	HUDPlusData2.m3backcolor.rcomp = rcompm3backcolor
	HUDPlusData2.m3backcolor.gcomp = gcompm3backcolor
	HUDPlusData2.m3backcolor.bcomp = bcompm3backcolor

	HUDPlusData2.pbackcolor = {}
	HUDPlusData2.pbackcolor.rcomp = rcomppbackcolor
	HUDPlusData2.pbackcolor.gcomp = gcomppbackcolor
	HUDPlusData2.pbackcolor.bcomp = bcomppbackcolor

	HUDPlusData2.p2backcolor = {}
	HUDPlusData2.p2backcolor.rcomp = rcompp2backcolor
	HUDPlusData2.p2backcolor.gcomp = gcompp2backcolor
	HUDPlusData2.p2backcolor.bcomp = bcompp2backcolor

	HUDPlusData2.p3backcolor = {}
	HUDPlusData2.p3backcolor.rcomp = rcompp3backcolor
	HUDPlusData2.p3backcolor.gcomp = gcompp3backcolor
	HUDPlusData2.p3backcolor.bcomp = bcompp3backcolor

	HUDPlusData2.tbackcolor = {}
	HUDPlusData2.tbackcolor.rcomp = rcomptbackcolor
	HUDPlusData2.tbackcolor.gcomp = gcomptbackcolor
	HUDPlusData2.tbackcolor.bcomp = bcomptbackcolor

	HUDPlusData2.mgreen = {}
	HUDPlusData2.mgreen.rcomp = rcompmgreen
	HUDPlusData2.mgreen.gcomp = gcompmgreen
	HUDPlusData2.mgreen.bcomp = bcompmgreen

	HUDPlusData2.purple = {}
	HUDPlusData2.purple.rcomp = rcomppurple
	HUDPlusData2.purple.gcomp = gcomppurple
	HUDPlusData2.purple.bcomp = bcomppurple

	HUDPlusData2.pblue = {}
	HUDPlusData2.pblue.rcomp = rcomppblue
	HUDPlusData2.pblue.gcomp = gcomppblue
	HUDPlusData2.pblue.bcomp = bcomppblue

	--EFFECTS------------------------------------------------------------------------------
	for i = 1, EffectNumber do

	HUDPlusData2[i] = {}
	HUDPlusData2[i].EffectName = Editwin[i].EffectName
	HUDPlusData2[i].ScreenName = Editwin[i].ScreenName
	HUDPlusData2[i].VisCriteria = Editwin[i].VisCriteria
	HUDPlusData2[i].FontChoice = Editwin[i].FontChoice.Text:GetText()
	HUDPlusData2[i].Abspres = Editwin[i].Abspres
	HUDPlusData2[i].Dis = Editwin[i].Dis
	HUDPlusData2[i].Color = Editwin[i].Color
	HUDPlusData2[i].X = Editwin[i].WarningWin:GetLeft()
	HUDPlusData2[i].Y = Editwin[i].WarningWin:GetTop()

	end

	HUDPlusData2.EffectNumber = EffectNumber
	HUDPlusData2.Effects = Effects

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HUDPlus2", HUDPlusData2 )
end

function Primwin:LoadDefaults()
	Loadtime = Turbine.Engine.GetGameTime()
	Fadetime = Loadtime + 4
	CritLevelT = .2
	LowLevelT = .5
	PLowLevelT = .4
	PCritLevelT = .2
	LowScroll:SetValue ( 50 )
	PLowScroll:SetValue( 40 )
	CriticalScroll:SetMaximum( 50 )
	CriticalScroll:SetValue( 20 )
	PCriticalScroll:SetMaximum( 40 )
	PCriticalScroll:SetValue( 20 )
	LowScrollLabel:SetText( "50% - Low" )
	PLowScrollLabel:SetText( "40% - Low" )
	CriticalScrollLabel:SetText( "20% - Critical" )
	PCriticalScrollLabel:SetText( "20% - Critical" )
	DHitLevel = 3000
	DHitScroll:SetValue( 3000 )
	DHitScrollLabel:SetText( "3000 - Hit Size" )
	AWarnFading = "0"

	quickslots = "1"
	QScheck:SetChecked( true )
	Barcheck:SetChecked( true )
	Bars = "1" 
	Moralewarn = "1"
	MWarncheck:SetChecked( true )
	Powerwarn = "1"
	PWarncheck:SetChecked( true )
	DHitWarncheck:SetChecked( true )
	InterruptCDcheck:SetChecked( true )
	PanCDcheck:SetChecked( true )
	BubCDcheck:SetChecked( true )
	Textcheck:SetChecked( true )
	CorruptionCDcheck:SetChecked( true )
	C1check:SetChecked( false )
	C2check:SetChecked( false )
	IndOnlycheck:SetChecked( false )
	IndOnly = "0" 
	DHitWarning = "1"
	InterruptCD = "1"
	CorruptionCD = "1"
	PanCD = "1"
	BubCD = "1"
	Text = "1"
	Cus1CD = "0"
	Cus2CD = "0"

	if PlayerClass == Turbine.Gameplay.Class.Champion
	then ChmpAtts = Player:GetClassAttributes()
	CurFervour = ChmpAtts:GetFervor()
	Meter = "1"
	MeterCheck:SetChecked(true)
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailCHMP.tga" )
	MeterBar:SetColor( red )
	elseif PlayerClass == Turbine.Gameplay.Class.Hunter
	then HntAtts = Player:GetClassAttributes()
	CurFocus = HntAtts:GetFocus()
	Meter = "1"
	MeterCheck:SetChecked(true)
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailHNT.tga" )
	MeterBar:SetBackColor( red )
	elseif PlayerClass == Turbine.Gameplay.Class.RuneKeeper
	then RKAtts = Player:GetClassAttributes()
	CurAtt = RKAtts:GetAttunement()
	Meter = "1"
	MeterCheck:SetChecked(true)
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailHNT.tga" )
	MeterBar:SetBackColor( red )
	else
	Meter = "0"
	MeterCheck:SetEnabled( false )
	MeterCheck:SetChecked( false )
	end

	MQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, MShortcut ) )
	PQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PShortcut ) )
	FQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, FShortcut ) )
	DQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, DShortcut ) )
	WQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, WShortcut ) )
	PoQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PoShortcut ) )
	MQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, MShortcut ) )
	PQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PMShortcut ) )
	FQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, FShortcut ) )
	DQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, DShortcut ) )
	WQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, WShortcut ) )
	PoQS:SetShortcut( Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Undefined, PoShortcut ) )

	MShortcut = MQSO:GetShortcut()
	PShortcut = PQSO:GetShortcut()
	FShortcut = FQSO:GetShortcut()
	DShortcut = DQSO:GetShortcut()
	WShortcut = WQSO:GetShortcut()
	PoShortcut = PoQSO:GetShortcut()

	BOSLabel:SetText( "30% Bar Opacity" )
	BopF = ( 30 )
	BopT = ( .3 )
	BOS:SetValue( 30 )

	MOSLabel:SetText( "30% Opacity" )
	MopF = ( 30 )
	MopT = ( .3 )
	MOS:SetValue( 30 )

	MWOSLabel:SetText( "100% Opacity" )
	MWopF = ( 100 )
	MWopT = ( 1 )
	MWOS:SetValue( 100 )
	MWarn:SetOpacity( 1 )

	PWOSLabel:SetText( "100% Opacity" )
	PWopF = ( 100 )
	PWopT = ( 1 )
	PWOS:SetValue( 100 )
	PWarn:SetOpacity( 1 )

	DHOSLabel:SetText( "100% Opacity" )
	DHopF = ( 100 )
	DHopT = ( 1 )
	DHOS:SetValue( 100 )
	DHitWarn:SetOpacity( 1 )

	PSL:SetText( "0" )
	PanScroll:SetValue( 0 )
	
	BSL:SetText( "0" )
	BubScroll:SetValue( 0 )

	ISL:SetText( "0" )
	IntScroll:SetValue( 0 )

	CSL:SetText( "0" )
	CorScroll:SetValue( 0 )

	C1SL:SetText( "0" )
	C1Scroll:SetValue( 0 )

	C2SL:SetText( "0" )
	C2Scroll:SetValue( 0 )

	PanRdytime = 0
	CorrRdytime = 0
	BubRdytime = 0
	IntRdytime = 0
	C1Rdytime = 0
	C2Rdytime = 0
	Pantext:SetText( "N/A" )
	Cortext:SetText( "N/A" )
	Bubtext:SetText( "N/A" )
	Inttext:SetText( "N/A" )
	C1text:SetText( "N/A" )
	C2text:SetText( "N/A" )
	PanCDing = "0"
	BubCDing = "0"
	CorrCDing = "0"
	IntCDing = "0"
	Cus1CDing = "0"
	Cus2CDing = "0"

	OOCcrit = "Out of Combat"
	OOClabel1:SetText( OOCcrit )

	Managercheck:SetChecked( false )
	loadwithman = "0"

	rcompmbackcolor = 0.24705882352941176470588235294118
	gcompmbackcolor = 0.72941176470588235294117647058824
	bcompmbackcolor = 0.27843137254901960784313725490196

	rcompm2backcolor = 1
	gcompm2backcolor = 0.89411764705882352941176470588235
	bcompm2backcolor = 0.29803921568627450980392156862745

	rcompm3backcolor = 1
	gcompm3backcolor = 0.18823529411764705882352941176471
	bcompm3backcolor = 0.21568627450980392156862745098039

	rcomppbackcolor = 0.28235294117647058823529411764706
	gcomppbackcolor = 0
	bcomppbackcolor = 0.8039215686274509803921568627451

	rcompp2backcolor = 0.44705882352941176470588235294118
	gcompp2backcolor = 0.67843137254901960784313725490196
	bcompp2backcolor = 1
	
	rcompp3backcolor = 0.06666666666666666666666666666667
	gcompp3backcolor = 0.87450980392156862745098039215686
	bcompp3backcolor = 1

	rcomptbackcolor = 1
	gcomptbackcolor = 0.14901960784313725490196078431373
	bcomptbackcolor = 0.95686274509803921568627450980392

	rcompmgreen = 0
	gcompmgreen = .7
	bcompmgreen = 0
	
	rcomppurple = 1
	gcomppurple = 0
	bcomppurple = .8
	
	rcomppblue = 0
	gcomppblue = 0
	bcomppblue = .7

	mbackcolor = Turbine.UI.Color( 0, rcompmbackcolor, gcompmbackcolor, bcompmbackcolor )
	mbackcolor2 = Turbine.UI.Color( 0, rcompm2backcolor, gcompm2backcolor, bcompm2backcolor )
	mbackcolor3 = Turbine.UI.Color( 0, rcompm3backcolor, gcompm3backcolor, bcompm3backcolor )
	pbackcolor = Turbine.UI.Color( 0, rcomppbackcolor, gcomppbackcolor, bcomppbackcolor )
	pbackcolor2 = Turbine.UI.Color( 0, rcompp2backcolor, gcompp2backcolor, bcompp2backcolor )
	pbackcolor3 = Turbine.UI.Color( 0, rcompp3backcolor, gcompp3backcolor, bcompp3backcolor )
	tbackcolor = Turbine.UI.Color( 1, rcomptbackcolor, gcomptbackcolor, bcomptbackcolor )
	mgreen = Turbine.UI.Color( rcompmgreen, gcompmgreen, bcompmgreen )
	purple = Turbine.UI.Color( rcomppurple, gcomppurple, bcomppurple )
	pblue = Turbine.UI.Color( rcomppblue, gcomppblue, bcomppblue )

	MRSB:SetValue( rcompmbackcolor * 255 )
	MRSBL:SetText( "Red - "..(rcompmbackcolor * 255) )
	MGSB:SetValue( gcompmbackcolor * 255 )
	MGSBL:SetText( "Green - "..(gcompmbackcolor * 255) )
	MBSB:SetValue( bcompmbackcolor * 255 )
	MBSBL:SetText( "Blue - "..(bcompmbackcolor * 255) )

	M2RSB:SetValue( rcompm2backcolor * 255 )
	M2RSBL:SetText( "Red - "..(rcompm2backcolor * 255) )
	M2GSB:SetValue( gcompm2backcolor * 255 )
	M2GSBL:SetText( "Green - "..(gcompm2backcolor * 255) )
	M2BSB:SetValue( bcompm2backcolor * 255 )
	M2BSBL:SetText( "Blue - "..(bcompm2backcolor * 255) )

	M3RSB:SetValue( rcompm3backcolor * 255 )
	M3RSBL:SetText( "Red - "..(rcompm3backcolor * 255) )
	M3GSB:SetValue( gcompm3backcolor * 255 )
	M3GSBL:SetText( "Green - "..(gcompm3backcolor * 255) )
	M3BSB:SetValue( bcompm3backcolor * 255 )
	M3BSBL:SetText( "Blue - "..(bcompm3backcolor * 255) )

	PRSB:SetValue( rcomppbackcolor * 255 )
	PRSBL:SetText( "Red - "..(rcomppbackcolor * 255) )
	PGSB:SetValue( gcomppbackcolor * 255 )
	PGSBL:SetText( "Green - "..(gcomppbackcolor * 255) )
	PBSB:SetValue( bcomppbackcolor * 255 )
	PBSBL:SetText( "Blue - "..(bcomppbackcolor * 255) )

	P2RSB:SetValue( rcompp2backcolor * 255 )
	P2RSBL:SetText( "Red - "..(rcompp2backcolor * 255) )
	P2GSB:SetValue( gcompp2backcolor * 255 )
	P2GSBL:SetText( "Green - "..(gcompp2backcolor * 255) )
	P2BSB:SetValue( bcompp2backcolor * 255 )
	P2BSBL:SetText( "Blue - "..(bcompp2backcolor * 255) )

	P3RSB:SetValue( rcompp3backcolor * 255 )
	P3RSBL:SetText( "Red - "..(rcompm3backcolor * 255) )
	P3GSB:SetValue( gcompp3backcolor * 255 )
	P3GSBL:SetText( "Green - "..(gcompp3backcolor * 255) )
	P3BSB:SetValue( bcompp3backcolor * 255 )
	P3BSBL:SetText( "Blue - "..(bcompp3backcolor * 255) )

	TRSB:SetValue( rcomptbackcolor * 255 )
	TRSBL:SetText( "Red - "..(rcomptbackcolor * 255) )
	TGSB:SetValue( gcomptbackcolor * 255 )
	TGSBL:SetText( "Green - "..(gcomptbackcolor * 255) )
	TBSB:SetValue( bcomptbackcolor * 255 )
	TBSBL:SetText( "Blue - "..(bcomptbackcolor * 255) )
	TCP:SetBackColor( tbackcolor )
	MBarT:SetBackColor( tbackcolor )

	MTRSB:SetValue( rcompmgreen * 255 )
	MTRSBL:SetText( "Red - "..(rcompmgreen * 255) )
	MTGSB:SetValue( gcompmgreen * 255 )
	MTGSBL:SetText( "Green - "..(gcompmgreen * 255) )
	MTBSB:SetValue( bcompmgreen * 255 )
	MTBSBL:SetText( "Blue - "..(bcompmgreen * 255) )
	MTCP:SetBackColor( mgreen )
	MRealLabel:SetForeColor( mgreen )
	MSlashLabel:SetForeColor( mgreen )
	MMaxLabel:SetForeColor( mgreen )
	MPercLabel:SetForeColor( mgreen )
	MPercLabel2:SetForeColor( mgreen )

	TTRSB:SetValue( rcomppurple * 255 )
	TTRSBL:SetText( "Red - "..(rcomppurple * 255) )
	TTGSB:SetValue( gcomppurple * 255 )
	TTGSBL:SetText( "Green - "..(gcomppurple * 255) )
	TTBSB:SetValue( bcomppurple * 255 )
	TTBSBL:SetText( "Blue - "..(bcomppurple * 255) )
	TTCP:SetBackColor( purple )
	TMRealLabel:SetForeColor( purple )
	TMSlashLabel:SetForeColor( purple )
	TMMaxLabel:SetForeColor( purple )
	TMPercLabel:SetForeColor( purple )
	TMPercLabel2:SetForeColor( purple )

	PTRSB:SetValue( rcomppblue * 255 )
	PTRSBL:SetText( "Red - "..(rcomppblue * 255) )
	PTGSB:SetValue( gcomppblue * 255 )
	PTGSBL:SetText( "Green - "..(gcomppblue * 255) )
	PTBSB:SetValue( bcomppblue * 255 )
	PTBSBL:SetText( "Blue - "..(bcomppblue * 255) )
	PTCP:SetBackColor( pblue )
	PRealLabel:SetForeColor( pblue )
	PSlashLabel:SetForeColor( pblue )
	PMaxLabel:SetForeColor( pblue )
	PPercLabel:SetForeColor( pblue )
	PPercLabel2:SetForeColor( pblue )
end

Primwin:LoadDefaults()

function HUDPlus:LoadData()
	PlayerClass = Player:GetClass()
	if PlayerClass == Turbine.Gameplay.Class.Champion
	then ChmpAtts = Player:GetClassAttributes()
	CurFervour = ChmpAtts:GetFervor()
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailCHMP.tga" )
	MeterBar:SetBackColor( red )
	elseif PlayerClass == Turbine.Gameplay.Class.Hunter
	then HntAtts = Player:GetClassAttributes()
	CurFocus = HntAtts:GetFocus()
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailHNT.tga" )
	MeterBar:SetBackColor( red )
	elseif PlayerClass == Turbine.Gameplay.Class.RuneKeeper
	then RKAtts = Player:GetClassAttributes()
	CurAtt = RKAtts:GetAttunement()
	MeterCheck:SetEnabled( true )
	MeterRail:SetBackground( "CajePlugins/HUDPlus/Resources/MeterRailHNT.tga" )
	MeterBar:SetBackColor( red )
	else
	Meter = "0"
	MeterCheck:SetEnabled( false )
	MeterCheck:SetChecked( false )
	end
	if loadwithman == "0" or LOADED == "0" then
	PanCDing = "0"
	BubCDing = "0"
	CorrCDing = "0"
	IntCDing = "0"
	Cus1CDing = "0"
	Cus2CDing = "0"
	PanRdytime = 0
	CorrRdytime = 0
	BubRdytime = 0
	IntRdytime = 0
	C1Rdytime = 0
	C2Rdytime = 0
		Turbine.PluginData.Load( Turbine.DataScope.Character, "HUDPlus", 
		function ( HUDPlusData )
			if HUDPlusData ~= nil then

			CritLevelT = HUDPlusData.CritLevel
			LowLevelT = HUDPlusData.LowLevel
			PCritLevelT = HUDPlusData.PCritLevel
			PLowLevelT = HUDPlusData.PLowLevel
			DHitLevel = HUDPlusData.DLevel

			LowScroll:SetValue ( LowLevelT * 100 )
			PLowScroll:SetValue( PLowLevelT * 100 )
			CriticalScroll:SetMaximum( LowLevelT * 100 )
			PCriticalScroll:SetMaximum( PLowLevelT * 100 )
			CriticalScroll:SetValue( CritLevelT * 100 )
			PCriticalScroll:SetValue( PCritLevelT * 100 )
			LowScrollLabel:SetText( ( LowLevelT * 100 ).."% - Low" )
			PLowScrollLabel:SetText( ( PLowLevelT * 100 ).."% - Low" )
			CriticalScrollLabel:SetText( ( CritLevelT * 100).."% - Critical" )
			PCriticalScrollLabel:SetText( ( PCritLevelT * 100).."% - Critical" )
			DHitScroll:SetValue( DHitLevel )
			DHitScrollLabel:SetText( DHitLevel.." - Hit Size" )
			AWarnFading = "0"

			quickslots = HUDPlusData.quickslots
			Bars = HUDPlusData.Bars
			Meter = HUDPlusData.Meter
			Moralewarn = HUDPlusData.Moralewarn
			Powerwarn = HUDPlusData.Powerwarn
			PanCD = HUDPlusData.PancD
			BubCD = HUDPlusData.BubCD
			Text = HUDPlusData.Text
			CorruptionCD = HUDPlusData.CorruptionCD
			InterruptCD = HUDPlusData.InterruptCD
			DHitWarning = HUDPlusData.DHitWarning
			Cus1CD = HUDPlusData.Cus1CD
			Cus2CD = HUDPlusData.Cus1CD
			IndOnly = HUDPlusData.IndOnly

			if quickslots == "1" then
			QScheck:SetChecked( true )
			else QScheck:SetChecked( false )
			end
			if Bars == "1" then
			Barcheck:SetChecked( true )
			else Barcheck:SetChecked( false )
			end
			if Meter == "1" then
			MeterCheck:SetChecked( true )
			else MeterCheck:SetChecked( false )
			Meter = "0"
			end
			if Moralewarn == "1" then
			MWarncheck:SetChecked( true )
			else MWarncheck:SetChecked( false )
			end
			if Powerwarn == "1" then
			PWarncheck:SetChecked( true ) 
			else PWarncheck:SetChecked( false )
			end
			if DHitWarning == "1" then
			DHitWarncheck:SetChecked( true )
			else DHitWarncheck:SetChecked( false )
			end
			if InterruptCD == "1" then
			InterruptCDcheck:SetChecked( true )
			else InterruptCDcheck:SetChecked( false )
			end
			if PanCD == "1" then
			PanCDcheck:SetChecked( true )
			else PanCDcheck:SetChecked( false )
			end
			if BubCD == "1" then
			BubCDcheck:SetChecked( true )
			else BubCDcheck:SetChecked( false )
			end
			if Text == "1" then
			Textcheck:SetChecked( true )
			else Textcheck:SetChecked( false )
			end
			if CorruptionCD == "1" then
			CorruptionCDcheck:SetChecked( true )
			else CorruptionCDcheck:SetChecked( false )
			end
			if Cus1CD == "1" then
			C1check:SetChecked( true )
			else C1check:SetChecked( false )
			end
			if Cus2CD == "1" then
			C2check:SetChecked( true )
			else C2check:SetChecked( false )
			end
			if IndOnly == "1" then
			IndOnlycheck:SetChecked( true )
			MQSG2:SetMouseVisible( true )
			--MQL:SetVisible( false )
			PQSG2:SetMouseVisible( true )
			--PQL:SetVisible( false )
			WQSG2:SetMouseVisible( true )
			--WQL:SetVisible( false )
			DQSG2:SetMouseVisible( true )
			--DQL:SetVisible( false )
			FQSG2:SetMouseVisible( true )
			--FQL:SetVisible( false )
			PoQSG2:SetMouseVisible( true )
			--PoQL:SetVisible( false )
			else IndOnlycheck:SetChecked( false )
			MQSG2:SetMouseVisible( false )
			--MQL:SetVisible( true )
			PQSG2:SetMouseVisible( false )
			--PQL:SetVisible( true )
			WQSG2:SetMouseVisible( false )
			--WQL:SetVisible( true )            --[[Quantity indicators disabled]]
			DQSG2:SetMouseVisible( false )
			--DQL:SetVisible( true )
			FQSG2:SetMouseVisible( false )
			--FQL:SetVisible( true )
			PoQSG2:SetMouseVisible( false )
			--PoQL:SetVisible( true )
			end

			MWopT = HUDPlusData.MWopT
			PWopT = HUDPlusData.PWopT
			DHopT = HUDPlusData.DHopT
			BopT = HUDPlusData.BopT
			MopT = HUDPlusData.MopT

			BOSLabel:SetText( (BopT * 100).."% Bar Opacity" )
			BopF = ( BopT * 100 )
			BOS:SetValue( BopF )

			MOSLabel:SetText( (MopT * 100).."% Opacity" )
			MopF = ( MopT * 100 )
			MOS:SetValue( MopF )

			MWOSLabel:SetText( ( MWopT * 100 ).."% Opacity" )
			MWopF = ( MWopT * 100 )
			MWOS:SetValue( MWopF )
			MWarn:SetOpacity( MWopF )

			PWOSLabel:SetText( (PWopT * 100).."% Opacity" )
			PWopF = ( PWopT * 100 )
			PWOS:SetValue( PWopF )
			PWarn:SetOpacity( PWopF )

			DHOSLabel:SetText( (DHopT * 100).."% Opacity" )
			DHopF = ( DHopT * 100 )
			DHOS:SetValue( DHopF )
			DHitWarn:SetOpacity( DHopF )

			MQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
			PQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
			FQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
			DQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
			WQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
			PoQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )
			MQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
			PQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
			FQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
			DQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
			WQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
			PoQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )

			Pantext:SetText( HUDPlusData.Panskill )
			Cortext:SetText( HUDPlusData.Corskill )
			Inttext:SetText( HUDPlusData.Intskill )
			Bubtext:SetText( HUDPlusData.Bubskill )
			C1text:SetText( HUDPlusData.C1skill )
			C2text:SetText( HUDPlusData.C2skill )

			PanScroll:SetValue( HUDPlusData.PanicCD )
			CorScroll:SetValue( HUDPlusData.CorCD )
			IntScroll:SetValue( HUDPlusData.IntCD )
			BubScroll:SetValue( HUDPlusData.BubbCD )
			C1Scroll:SetValue( HUDPlusData.C1CD )
			C2Scroll:SetValue( HUDPlusData.C2CD )
			PSL:SetText( HUDPlusData.PanicCD )
			BSL:SetText( HUDPlusData.BubbCD )
			ISL:SetText( HUDPlusData.IntCD )
			CSL:SetText( HUDPlusData.CorCD )
			C1SL:SetText( HUDPlusData.C1CD )
			C2SL:SetText( HUDPlusData.C2CD )

			OOCcrit = HUDPlusData.OOCcrit
			OOClabel1:SetText( OOCcrit )

			Cus1CD = HUDPlusData.Cus1CD
			Cus2CD = HUDPlusData.Cus2CD
			if Cus1CD == "1" then
			C1check:SetChecked( true )
			else C1check:SetChecked( false )
			end
			if Cus2CD == "1" then
			C2check:SetChecked( true )
			else C2check:SetChecked( false )
			end

			MData = HUDPlusData.MData
			PData = HUDPlusData.PData
			DData = HUDPlusData.DData
			WData = HUDPlusData.WData
			FData = HUDPlusData.FData
			PoData = HUDPlusData.PoData
			MType = HUDPlusData.MType
			PType = HUDPlusData.PType
			DType = HUDPlusData.DType
			WType = HUDPlusData.WType
			FType = HUDPlusData.FType
			PoType = HUDPlusData.PoType
			
			loadwithman = HUDPlusData.loadwithman

				if loadwithman == "1" then
				Managercheck:SetChecked( true )
				else Managercheck:SetChecked( false )
				end
			if loadwithman == "0" then
				MQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
				PQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
				FQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
				DQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
				WQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
				PoQSO:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )
				MQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.MType, HUDPlusData.MData ) )
				PQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PType, HUDPlusData.PData ) )
				FQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.FType, HUDPlusData.FData ) )
				DQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.DType, HUDPlusData.DData ) )
				WQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.WType, HUDPlusData.WData ) )
				PoQS:SetShortcut( Turbine.UI.Lotro.Shortcut( HUDPlusData.PoType, HUDPlusData.PoData ) )
			end

			MWarn:SetLeft( HUDPlusData.MWarnX )
			MWarn:SetTop( HUDPlusData.MWarnY )
			PWarn:SetLeft( HUDPlusData.PWarnX )
			PWarn:SetTop( HUDPlusData.PWarnY )
			DHitWarn:SetLeft( HUDPlusData.DHitWarnX )
			DHitWarn:SetTop( HUDPlusData.DHitWarnY )
			PanicCD:SetLeft( HUDPlusData.PanicCDX )
			PanicCD:SetTop( HUDPlusData.PanicCDY )
			BubbleCD:SetLeft( HUDPlusData.BubbleCDX )
			BubbleCD:SetTop( HUDPlusData.BubbleCDY )
			IntCD:SetLeft( HUDPlusData.IntCDX )
			IntCD:SetTop( HUDPlusData.IntCDY )
			CorrCD:SetLeft( HUDPlusData.CorrCDX )
			CorrCD:SetTop( HUDPlusData.CorrCDY )
			C1CD:SetLeft( HUDPlusData.C1CDX )
			C1CD:SetTop( HUDPlusData.C1CDY )
			C2CD:SetLeft( HUDPlusData.C2CDX )
			C2CD:SetTop( HUDPlusData.C2CDY )

			MQSG:SetLeft( HUDPlusData.MQSGX )
			MQSG:SetTop( HUDPlusData.MQSGY )
			PQSG:SetLeft( HUDPlusData.PQSGX )
			PQSG:SetTop( HUDPlusData.PQSGY )
			FQSG:SetLeft( HUDPlusData.FQSGX )
			FQSG:SetTop( HUDPlusData.FQSGY )
			DQSG:SetLeft( HUDPlusData.DQSGX )
			DQSG:SetTop( HUDPlusData.DQSGY )
			WQSG:SetLeft( HUDPlusData.WQSGX )
			WQSG:SetTop( HUDPlusData.WQSGY )
			PoQSG:SetLeft( HUDPlusData.PoQSGX )
			PoQSG:SetTop( HUDPlusData.PoQSGY )

			MBarWin:SetLeft( HUDPlusData.MBarX )
			MBarRail:SetLeft( HUDPlusData.MBarX )
			MBarWin:SetTop( HUDPlusData.MBarY )
			MBarRail:SetTop( HUDPlusData.MBarY )
			PBarWin:SetLeft( HUDPlusData.PBarX )
			PBarRail:SetLeft( HUDPlusData.PBarX )
			PBarWin:SetTop( HUDPlusData.PBarY )
			PBarRail:SetTop( HUDPlusData.PBarY )

			MTWin:SetTop( HUDPlusData.MTWinY )
			MTWin:SetLeft( HUDPlusData.MTWinX )
			PTWin:SetLeft( HUDPlusData.PTWinX )
			PTWin:SetTop( HUDPlusData.PTWinY )
			TTWin:SetLeft( HUDPlusData.TTWinX )
			TTWin:SetTop( HUDPlusData.TTWinY )

			MeterWin:SetLeft( HUDPlusData.MeterBarX )
			MeterRail:SetLeft( HUDPlusData.MeterBarX )
			MeterWin:SetTop( HUDPlusData.MeterBarY )
			MeterRail:SetTop( HUDPlusData.MeterBarY )

			HUDPlus:LoadData2()

			else Primwin:LoadDefaults()
			end
		end
		);
	end
end

function HUDPlus:LoadData2()
	Turbine.PluginData.Load( Turbine.DataScope.Character, "HUDPlus2", 
	function ( HUDPlusData2 )
			DataLoading2 = "1" 
			if HUDPlusData2 ~= nil then
			--COLOR------------------------------------------------------------------------------------------------

			rcompmbackcolor = HUDPlusData2.mbackcolor.rcomp
			gcompmbackcolor = HUDPlusData2.mbackcolor.gcomp
			bcompmbackcolor = HUDPlusData2.mbackcolor.bcomp

			rcompm2backcolor = HUDPlusData2.m2backcolor.rcomp
			gcompm2backcolor = HUDPlusData2.m2backcolor.gcomp
			bcompm2backcolor = HUDPlusData2.m2backcolor.bcomp

			rcompm3backcolor = HUDPlusData2.m3backcolor.rcomp
			gcompm3backcolor = HUDPlusData2.m3backcolor.gcomp
			bcompm3backcolor = HUDPlusData2.m3backcolor.bcomp

			rcomppbackcolor = HUDPlusData2.pbackcolor.rcomp
			gcomppbackcolor = HUDPlusData2.pbackcolor.gcomp
			bcomppbackcolor = HUDPlusData2.pbackcolor.bcomp

			rcompp2backcolor = HUDPlusData2.p2backcolor.rcomp
			gcompp2backcolor = HUDPlusData2.p2backcolor.gcomp
			bcompp2backcolor = HUDPlusData2.p2backcolor.bcomp
	
			rcompp3backcolor = HUDPlusData2.p3backcolor.rcomp
			gcompp3backcolor = HUDPlusData2.p3backcolor.gcomp
			bcompp3backcolor = HUDPlusData2.p3backcolor.bcomp

			rcomptbackcolor = HUDPlusData2.tbackcolor.rcomp
			gcomptbackcolor = HUDPlusData2.tbackcolor.gcomp
			bcomptbackcolor = HUDPlusData2.tbackcolor.bcomp

			rcompmgreen = HUDPlusData2.mgreen.rcomp
			gcompmgreen = HUDPlusData2.mgreen.gcomp
			bcompmgreen = HUDPlusData2.mgreen.bcomp
	
			rcomppurple = HUDPlusData2.purple.rcomp
			gcomppurple = HUDPlusData2.purple.gcomp
			bcomppurple = HUDPlusData2.purple.bcomp
	
			rcomppblue = HUDPlusData2.pblue.rcomp
			gcomppblue = HUDPlusData2.pblue.gcomp
			bcomppblue = HUDPlusData2.pblue.bcomp

			mbackcolor = Turbine.UI.Color( 0, rcompmbackcolor, gcompmbackcolor, bcompmbackcolor )
			mbackcolor2 = Turbine.UI.Color( 0, rcompm2backcolor, gcompm2backcolor, bcompm2backcolor )
			mbackcolor3 = Turbine.UI.Color( 0, rcompm3backcolor, gcompm3backcolor, bcompm3backcolor )
			pbackcolor = Turbine.UI.Color( 0, rcomppbackcolor, gcomppbackcolor, bcomppbackcolor )
			pbackcolor2 = Turbine.UI.Color( 0, rcompp2backcolor, gcompp2backcolor, bcompp2backcolor )
			pbackcolor3 = Turbine.UI.Color( 0, rcompp3backcolor, gcompp3backcolor, bcompp3backcolor )
			tbackcolor = Turbine.UI.Color( 1, rcomptbackcolor, gcomptbackcolor, bcomptbackcolor )
			mgreen = Turbine.UI.Color( rcompmgreen, gcompmgreen, bcompmgreen )
			purple = Turbine.UI.Color( rcomppurple, gcomppurple, bcomppurple )
			pblue = Turbine.UI.Color( rcomppblue, gcomppblue, bcomppblue )

			MRSB:SetValue( rcompmbackcolor * 255 )
			MRSBL:SetText( "Red - "..(math.floor( rcompmbackcolor * 255) ) )
			MGSB:SetValue( gcompmbackcolor * 255 )
			MGSBL:SetText( "Green - "..( math.floor(gcompmbackcolor * 255) ) )
			MBSB:SetValue( bcompmbackcolor * 255 )
			MBSBL:SetText( "Blue - "..(math.floor(bcompmbackcolor * 255) ) )

			M2RSB:SetValue( rcompm2backcolor * 255 )
			M2RSBL:SetText( "Red - "..(math.floor(rcompm2backcolor * 255) ) )
			M2GSB:SetValue( gcompm2backcolor * 255 )
			M2GSBL:SetText( "Green - "..( math.floor(gcompm2backcolor * 255) ) )
			M2BSB:SetValue( bcompm2backcolor * 255 )
			M2BSBL:SetText( "Blue - "..( math.floor(bcompm2backcolor * 255) ) )

			M3RSB:SetValue( rcompm3backcolor * 255 )
			M3RSBL:SetText( "Red - "..( math.floor(rcompm3backcolor * 255) ) )
			M3GSB:SetValue( gcompm3backcolor * 255 )
			M3GSBL:SetText( "Green - "..( math.floor(gcompm3backcolor * 255) ) )
			M3BSB:SetValue( bcompm3backcolor * 255 )
			M3BSBL:SetText( "Blue - "..(math.floor(bcompm3backcolor * 255) ) )

			PRSB:SetValue( rcomppbackcolor * 255 )
			PRSBL:SetText( "Red - "..( math.floor(rcomppbackcolor * 255) ) )
			PGSB:SetValue( gcomppbackcolor * 255 )
			PGSBL:SetText( "Green - "..( math.floor(gcomppbackcolor * 255) ) )
			PBSB:SetValue( bcomppbackcolor * 255 )
			PBSBL:SetText( "Blue - "..( math.floor(bcomppbackcolor * 255) ) )

			P2RSB:SetValue( rcompp2backcolor * 255 )
			P2RSBL:SetText( "Red - "..( math.floor(rcompp2backcolor * 255) ) )
			P2GSB:SetValue( gcompp2backcolor * 255 )
			P2GSBL:SetText( "Green - "..( math.floor(gcompp2backcolor * 255) ) )
			P2BSB:SetValue( bcompp2backcolor * 255 )
			P2BSBL:SetText( "Blue - "..( math.floor(bcompp2backcolor * 255) ) )

			P3RSB:SetValue( rcompp3backcolor * 255 )
			P3RSBL:SetText( "Red - "..( math.floor(rcompm3backcolor * 255) ) )
			P3GSB:SetValue( gcompp3backcolor * 255 )
			P3GSBL:SetText( "Green - "..( math.floor(gcompp3backcolor * 255) ) )
			P3BSB:SetValue( bcompp3backcolor * 255 )
			P3BSBL:SetText( "Blue - "..( math.floor(bcompp3backcolor * 255) ) )

			TRSB:SetValue( rcomptbackcolor * 255 )
			TRSBL:SetText( "Red - "..( math.floor(rcomptbackcolor * 255) ) )
			TGSB:SetValue( gcomptbackcolor * 255 )
			TGSBL:SetText( "Green - "..( math.floor(gcomptbackcolor * 255) ) )
			TBSB:SetValue( bcomptbackcolor * 255 )
			TBSBL:SetText( "Blue - "..( math.floor(bcomptbackcolor * 255) ) )
			TCP:SetBackColor( tbackcolor )
			MBarT:SetBackColor( tbackcolor )

			MTRSB:SetValue( rcompmgreen * 255 )
			MTRSBL:SetText( "Red - "..( math.floor(rcompmgreen * 255) ) )
			MTGSB:SetValue( gcompmgreen * 255 )
			MTGSBL:SetText( "Green - "..( math.floor(gcompmgreen * 255) ) )
			MTBSB:SetValue( bcompmgreen * 255 )
			MTBSBL:SetText( "Blue - "..( math.floor(bcompmgreen * 255) ) )
			MTCP:SetBackColor( mgreen )
			MRealLabel:SetForeColor( mgreen )
			MSlashLabel:SetForeColor( mgreen )
			MMaxLabel:SetForeColor( mgreen )
			MPercLabel:SetForeColor( mgreen )
			MPercLabel2:SetForeColor( mgreen )

			TTRSB:SetValue( rcomppurple * 255 )
			TTRSBL:SetText( "Red - "..( math.floor(rcomppurple * 255) ) )
			TTGSB:SetValue( gcomppurple * 255 )
			TTGSBL:SetText( "Green - "..( math.floor(gcomppurple * 255) ) )
			TTBSB:SetValue( bcomppurple * 255 )
			TTBSBL:SetText( "Blue - "..( math.floor(bcomppurple * 255) ) )
			TTCP:SetBackColor( purple )
			TMRealLabel:SetForeColor( purple )
			TMSlashLabel:SetForeColor( purple )
			TMMaxLabel:SetForeColor( purple )
			TMPercLabel:SetForeColor( purple )
			TMPercLabel2:SetForeColor( purple )

			PTRSB:SetValue( rcomppblue * 255 )
			PTRSBL:SetText( "Red - "..( math.floor(rcomppblue * 255) ) )
			PTGSB:SetValue( gcomppblue * 255 )
			PTGSBL:SetText( "Green - "..( math.floor(gcomppblue * 255) ) )
			PTBSB:SetValue( bcomppblue * 255 )
			PTBSBL:SetText( "Blue - "..( math.floor(bcomppblue * 255) ) )
			PTCP:SetBackColor( pblue )
			PRealLabel:SetForeColor( pblue )
			PSlashLabel:SetForeColor( pblue )
			PMaxLabel:SetForeColor( pblue )
			PPercLabel:SetForeColor( pblue )
			PPercLabel2:SetForeColor( pblue )

			if EffL == "0" then
			EffL = "1"
			EffectNumber = HUDPlusData2.EffectNumber
			Effects = HUDPlusData2.Effects
			if Effects == "1" then
				Echeck:SetChecked( true )
			elseif Effects == "0" then
				Echeck:SetChecked( false )
			end

			for i = 1, EffectNumber do

				Ebox.AddNewItem( HUDPlusData2[i].EffectName, HUDPlusData2[i].ScreenName, HUDPlusData2[i].VisCriteria, HUDPlusData2[i].FontChoice, HUDPlusData2[i].Abspres, HUDPlusData2[i].Dis, HUDPlusData2[i].Color, i )

				Editwin[i].X = HUDPlusData2[i].X
				Editwin[i].Y = HUDPlusData2[i].Y

				Editwin[i].WarningWin:SetLeft( Editwin[i].X )
				Editwin[i].WarningWin:SetTop( Editwin[i].Y )
			end

			end

			end
			Player:MoraleChanged()
			Player:PowerChanged()
			EffectList:EffectAdded()
			DataLoading2 = "0"
	end
	);
end

--[[function HUDPlus:LoadFlags()
	Turbine.PluginData.Load( Turbine.DataScope.Character, "HUDPlusF", 
	function ( HUDPlusFlags )
	if HUDPlusFlags ~= nil then
	MLastPot = HUDPlusFlags.MLastPot
	PLastPot = HUDPlusFlags.PLastPot
	DLastPot = HUDPlusFlags.DLastPot                Quantity Indicators Disabled
	WLastPot = HUDPlusFlags.WLastPot
	PoLastPot = HUDPlusFlags.PoLastPot
	FLastPot = HUDPlusFlags.FLastPot
	end
	end
	);
end

HUDPlus:LoadFlags();]]

HUDPlus:LoadData()

function SwindowMaster:Update() --Disabled after done loading
	
	Primwin.ManloadQS()

	LocTime = Turbine.Engine.GetLocalTime()
	FrameTime = Turbine.Engine.GetGameTime()

	Primwin:LoadShowForce()

end

function Primwin:Update()

	LocTime = Turbine.Engine.GetLocalTime()
	FrameTime = Turbine.Engine.GetGameTime()

	Primwin:CheckFlash()

	Primwin:EffectDrag()

	Primwin:OptOverride()

	--Primwin:QuickslotScan() Quantity indicator disabled

	Primwin:SkillTimers()

	Primwin:ScanDragging()

	Primwin:ScanHudVis2()

end

Primwin:DefinePlayer()
Player:MoraleChanged()
Player:PowerChanged()
EffectList:EffectAdded()

import "CajePlugins.HUDPlus.OptionsMain"